//#define non_alarm_inversion
//#define reverse_display
#define china 1        //   -    "" ,  - 
#define irlml 1        //   -       

#define lithium        //   -  c  ,      

#define blink_led_on_pulse //   

unsigned char delay_positive_pump=2;        //    


eeprom int sleep_time=30;          //    
eeprom int alarm_level=50;         //     

#ifdef irlml
eeprom unsigned char delay_pump_def=13;     //           (330 )
eeprom unsigned char impulse_pump_def=8;     //              (330 )
eeprom unsigned char delay_positive_pump_eeprom = 2; //    
#else
eeprom unsigned char delay_pump_def=100;     //           (330 )
eeprom unsigned char impulse_pump_def=16;     //              (330 )
eeprom unsigned char delay_positive_pump_eeprom = 2; //    
#endif
eeprom char sound_eep=1;


char menu_select=1;
bit menu_active=0;
bit sound_bit=1;
bit imp=0;


unsigned int impulse_pump;
unsigned int delay_pump;
unsigned char chrg_tick=0;

unsigned char key_press=0;

unsigned char battery_procent=0;

unsigned char second=0;

unsigned char second_tick=0;
unsigned char minute_tick=0;
unsigned char hour_tick=0;
unsigned int impulse_massive[38];
unsigned long hour_doze=0;
unsigned long day_doze=0;
unsigned long all_doze=0;
unsigned int days=0;

unsigned int VoltLevel=0;

bit alarm=0;
bit user_cancel_alarm=0;

bit impulse_recive=0;


bit black_light_enable=0;

unsigned int display_time=0;

unsigned int div_gpaph=6;

unsigned char error_count=0;
unsigned char beep_count=0;

bit beep=0;
bit beep_active=0;
bit poweroff_bit=0;

bit need_update=0; 


void led_refresh(unsigned char command);


#define blue_led_pin  PORTD.5
#define red_led_pin   PORTD.0
#define beep_pin      PORTC.1
#define trans         PORTD.1
#define key           PIND.2 //(int0)
#define key_plus      PINC.2 //(key +)
#define impulse       PIND.3 //(int1)

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#include <n3310lcd.c>

#include <microdozik.h>
#include <display_data.h> 


//********************************************************************
void check_battery();

//--------------------------------- --------------------------//
interrupt [ADC_INT] void voidadc_isr(void)
{
#ifdef lithium 
	VoltLevel=(116*255)/(ADCH-1); // 1.16  ( 8   1.01  1.2      ADC_VALUE = V_BG * 255/Vcc)
#else    
	VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
#endif    
}

//********************************************************************

interrupt [EXT_INT1] void ext_int1_isr(void)
{
unsigned char i,j;

    beep_pin=0;
    delay_us(1);
    
    need_update=1;
    impulse_recive=1; 
    trans=0; //      
    impulse_massive[0]++;
hour_doze++;

#pragma optsize-

    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        for(j=delay_positive_pump;j>0;j--)nop();
        trans=0;
        delay_us(10);     //11
    }
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
#asm("wdr")

imp=1;
//    beep_pin=0;
}

//********************************************************************

interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
TCNT0=0xFF;
if(!beep)
{
    TIMSK=0x40;
    beep_pin=0;
    led_refresh(1);
}
else
{
    if(beep_count<254)
    {
        beep_count++;
        if(!beep_active)
        {
            beep_pin=0;
            led_refresh(1);
            beep_active=1;
        }
        else
        {
            led_refresh(0);
            beep_pin=1;
            beep_active=0;
        }
    }
    else
    {
        
        if(alarm&(!user_cancel_alarm))
        {
            beep_count=0;
        }
        else
        {
            beep_pin=0;
            led_refresh(1);
            beep_count=0;
            TIMSK=0x40;
            beep=0;
        }
        
    }
}
}
//********************************************************************
  
interrupt [EXT_INT0] void ext_int0_isr(void)
{
bit key2_pressed=0;
int i;

need_update=1;
trans=0;

if(!power_down)
  {  
    if(alarm&(!user_cancel_alarm))
    {
        user_cancel_alarm=1;
        beep=0;
        beep_pin=0;
        led_refresh(1);
        TIMSK=0x40;
    }
    else
    {
        if(menu_active)
        {
           menu_select++;
        }
    }
  }    

    display_time=0;
    if(TIMSK!=0x00)LcdPwrOn();
    while((!key)&(!poweroff_bit))  //    
    {
        delay_ms(100);
        #asm("wdr")
        if(!key_plus)key2_pressed=1;
        key_press++;
        
        if((key_press%10)==0)for(i=800;i>0;i--)
        {
            led_refresh(0);
            beep_pin=1;
            delay_us(50);
            beep_pin=0;
            if(!power_down)led_refresh(2);
            delay_us(300);
        } 

        if(key_press>50) //    5- ,   
        {
        poweroff_bit=1;
        GICR=0x00;
        } 
    }
    if((key_press>=10)&(key_press<=50)&key2_pressed)
    {
        if(menu_active==0)
            {
                menu_active=1;
            }
    }
    else
    {
        if((key_press>=10)&(key_press<=50)&(!key2_pressed))
        {
            if(!power_down)
            {   
                if(black_light_enable){black_light_enable=0;}
                else{black_light_enable=1;}
            }
        }
    }
    key_press=0;  

}

//********************************************************************

interrupt [TIM2_OVF] void timer2_comp_ovf(void)
{
char i,j;
    div_gpaph=6;
    for(i=36;i>0;i--)
    {
    if(impulse_massive[i]>div_gpaph)div_gpaph=impulse_massive[i];
    impulse_massive[i]=impulse_massive[i-1]; //  
    }
    impulse_massive[0]=0;

    need_update=1;
        
    second_tick++;
    chrg_tick++;
 
    if (chrg_tick>10) chrg_tick=0;
    if(second_tick>59)
    {  
        second_tick=0;
        minute_tick++;
        check_battery();       
    }
    
    if(minute_tick>59)
    {
        minute_tick=0;
        hour_tick++;
        day_doze+=hour_doze/100; // 60 * 60 / 36 = 100.    
        hour_doze=0;
    }
    if(hour_tick>23)
    {
        hour_tick=0;
        days++;
        all_doze+=day_doze;
        day_doze=0;
    }
             
    
    second++;
    if(display_time<1000)display_time++;
    
        GICR=0x00;
    led_refresh(0);
#pragma optsize-
    for(i=0;i<delay_pump;i++) //  def
    {
        trans=1;
        for(j=delay_positive_pump;j>0;j--)nop();
        trans=0;
        delay_us(10);   // 7
        #asm("wdr")
    }
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
//#asm("wdr")
    delay_us(25); //25
    led_refresh(1);
    GICR=0xC0;

    if(sleep_time==0)display_time=0;
    if((display_time>sleep_time)&(!alarm))LcdPwrOff();

}

//********************************************************************
  
  void main(void)
{
unsigned int i,j;


#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

#asm("cli");  



TCCR0=0x05;
TCNT0=0xFF;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

  ASSR = (1<<AS2);
     //        
  delay_ms(1000);
     // 3.    TCNT2, OCR2x, and TCCR2B.
  TCNT2 = 0;
     /*   = 128
       32.768 kHz / 128 / 256 =    . */
  TCCR2 |= (1<<CS22) | (1<<CS20);            


TIMSK=0x40;
TIMSK |= (1<<OCIE2); //     2

GICR=0xC0;
MCUCR=0xB0;
GIFR=0xC0;

PORTD.3=0; //   
DDRD.3=0;

PORTD.2=1; //   
DDRD.2=0;

PORTC.2=1; //    "+"
DDRC.2=0;

PORTC.1=0; // 
DDRC.1=1;

PORTD.0=0; //  
DDRD.0=1;

PORTD.5=0; //  
DDRD.5=1;

PORTD.1=0; //    .
DDRD.1=1;


delay_positive_pump=delay_positive_pump_eeprom;
sound_bit=sound_eep;

LcdPwrOff();
delay_ms(100);
LcdPwrOn();
delay_ms(100);
 

	LcdClear();

	sprintf (lcd_buf, "   -2   ");
	LcdStringInv(1,1);
    sprintf (lcd_buf, " FW:1.2.3 ");
	LcdString(1,3);
    //sprintf (lcd_buf, "     by Shodan");
	//LcdString(1,4);
    //sprintf (lcd_buf, " mod by MadOrc");
	//LcdString(1,5);

    LcdUpdate();

    sprintf(lcd_buf, "");
	LcdStringInv(1,6);
	LcdUpdate();

check_battery();

{

#asm("cli")
    j=0;    
    for(i=0;i<60000;i++) //  
    {
        j++;
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(40);
        #asm("wdr")
        if(j==10000)
        {
        j=0;
            sprintf (lcd_buf, ".");
	        LcdStringInv(9+(i/10000),6);
	        LcdUpdate();
        }

    }
} 
#asm("sei") // 

LcdClear();
///////////////////////////////////////////////////////////
while (1)
{

if(need_update)
{
    need_update=0;
    calc_counters();
    #asm("wdr")
    if(poweroff_bit)
    {
        TIMSK=0x40;
        beep=0;
        beep_pin=0;
        poweroff();
    }

    alarm_check();
    menu_modification_check();
    
    led_refresh(2);

    if(!power_down)
    {
        LcdClear_massive();
        if(menu_active)
        {menu();}
        else
        {main_window_draw();}
    }

}


if(!menu_active)
{
    if(!beep)
    {
        #asm("sleep")
    }
    #asm("wdr")
}
else
{
    need_update=1;
}
    	
};
}

//-------------------------------------------