void pump();
void alarm_check();
void check_battery();
void check_sbm20();
void read_adc();


/***********************************************************************************************/

void pump()
{
unsigned int i;

if(need_pump) 
{
    GICR=0x00;
    for(i=0;i<delay_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(10);
        #asm("wdr")
    }
    delay_us(25);
    need_pump=0;
    GICR=0xC0;
}
}

//  ********************************************************************


void alarm_check()
{
    if((rad_fon>alarm_level)&(!user_cancel_alarm)){beep=1;display=1;alarm=1;search_mode=0;fon_mode=1;}
    if((rad_fon<alarm_level)||(user_cancel_alarm)){beep=0;alarm=0;}
}

//  ********************************************************************

void check_battery()
{
unsigned int pump_multipiller=100;
 read_adc();

if(VoltLevel<420) //    4.2,   .
{
pump_multipiller=(((420-VoltLevel)*100)*3)/420;
impulse_pump=impulse_pump_def+((impulse_pump_def*pump_multipiller)/100);
delay_pump=delay_pump_def+((delay_pump_def*pump_multipiller)/100);
#asm("wdr")
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}

 
 if(VoltLevel<300) //    3 ,  .  2.7  ,   3     
 {
         beep = 1;
         delay_ms(40);
         beep = 0;
         delay_ms(40);
         beep = 1;
         delay_ms(40);
         beep = 0;
         delay_ms(70);
         beep = 1;
         delay_ms(40);
         beep = 0;
         #asm("wdr")
 }

}
//  ********************************************************************

void check_sbm20()
{
if(rad_fon==0){error_count++;}
else{error_count=0;}

 if(error_count>3) { need_pump=1; pump(); } //     :)       
 if(error_count>5) //    ,  .
 {
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
 }

}
//  ********************************************************************

void read_adc()
{       unsigned int  tmpv=0;
        unsigned char ixi=64,MCUCR_def;

        #asm("sei");        //   
        ADMUX= 0b11100111;
        
    ADCSRA=0b10011111;
    MCUCR_def=MCUCR; 
        MCUCR=0x90;      //    
        delay_us(125);
        TIMSK=0x00; 
        while(ixi>0)
        {
         #asm("sleep");    //   
         #asm("wdr");
         tmpv+=VoltLevel;                   
         ixi--;
        }
    TIMSK=0x41; 
        MCUCR=MCUCR_def;       //   .
        ADCSRA=0x00; 
    ACSR=0x00; 
    ADMUX=0x00;   //       
            
        VoltLevel=(tmpv>>6);
        //VoltLevel=111;
}
