void pump();
void calc_counters();
void alarm_check();
void check_battery();
void check_sbm20();


/***********************************************************************************************/
void pump()
{
unsigned int i;
if(need_pump_by_impulse>0)
{
    GICR=0x00;
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(5);
        #asm("wdr")
    }
    need_pump_by_impulse--;
    GICR=0xC0;
}


if(need_pump) 
{
    GICR=0x00;
    for(i=0;i<delay_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(10);
        #asm("wdr")
    }
    need_pump=0;
    GICR=0xC0;
}
}

//********************************************************************

void calc_counters()
{
unsigned long doze=0; 
char i;
impulse_count=0;
for(i=0;i<37;i++)impulse_count+=impulse_massive[i];
if(!doze_mode)tem=impulse_count;

#asm("wdr")
 if(second>36)
 {
       check_sbm20();
       impulse_count=0;
       second=0;
       impulse_massive[0]=0;
       ready=1;
 }  
 
 //display=1;
 //display_time=1;
 //doze_mode=1;
        
 if(!doze_mode)
 {  if(impulse_count!=impulse_count_old)
    {
       impulse_count_old=impulse_count;
       
       if(tem>9999)
       {
            razl_1=10; //    "- - - -"
            razl_2=10;
            razl_3=10;
            razl_4=10;
       }
       else
       {
            razl_1=tem/1000;    // 
            razl_2=(tem%1000)/100;
            razl_3=(tem%100)/10;
            razl_4=tem%10;
       }
    }
 }

 else
 {
    for(i=0;i<24;i++)doze+=doze_massive[i]/100;
    
    tem=doze;
    if(tem>9999){razl_1=10;razl_2=10;razl_3=10;razl_4=10;}
       else
       {
        razl_1=tem/1000;    // 
        razl_2=(tem%1000)/100;
        razl_3=(tem%100)/10;
        razl_4=tem%10;
       }
 }
}

//********************************************************************

void alarm_check()
{
    if((impulse_count>60)&(!user_cancel_alarm)){beep=1;display=1;alarm=1;}
    if(impulse_count<60){beep=0;alarm=0;user_cancel_alarm=0;}
}

//********************************************************************

void check_battery()
{
 read_adc();
 if(VoltLevel<330) //    3.3,  .
 {
         beep = 1;
         delay_ms(30);
         beep = 0;
         delay_ms(60);
         beep = 1;
         delay_ms(30);
         beep = 0;
         delay_ms(60);
         beep = 1;
         delay_ms(30);
         beep = 0;
 }

}
//********************************************************************

void check_sbm20()
{
if(impulse_count==0){error_count++;}
else{error_count=0;}

 if(error_count>5) //    ,  .
 {
         beep = 1;
         delay_ms(1000);
         beep = 0;
         delay_ms(600);
         beep = 1;
         delay_ms(1000);
         beep = 0;
         delay_ms(600);
         beep = 1;
         delay_ms(1000);
         beep = 0;
 }

}
//********************************************************************
