void menu();
void main_window_draw();
void menu_modification_check();


/***********************************************************************************************/

void menu_modification_check()
{
unsigned char i;
if((!key_plus)&menu_active)
{
 if(!service_menu)
 { 
    switch(menu_select)
    {
    case 1:
    if((alarm_level>=1000)&(alarm_level<9999))alarm_level+=1000;
    if((alarm_level>=100)&(alarm_level<1000))alarm_level+=100;
    if(alarm_level<100)alarm_level+=25;
    if(alarm_level>9999)alarm_level=0;
        break;
    case 2:
        if((sleep_time>=60)&(sleep_time<700))sleep_time+=60;
        if((sleep_time>=10)&(sleep_time<60))sleep_time+=10;
        if(sleep_time<10)sleep_time=10;
        if(sleep_time>600)sleep_time=0;
        break;
    case 3:
        if(sound_bit){sound_bit=0;sound_eep=0;}
        else{sound_bit=1;sound_eep=1;}
        break;
    case 4:
        for(i=0;i<24;i++)
        {doze_massive[i]=0; // .
         doze_massive[26]=0;
         TIMSK=0x41;
         beep=1;
         delay_ms(100);
         second_tick=0;
         minute_tick=0;
         hour_tick=0;
         day_tick=0;
        }

        break;
    }
 }else{
    switch(menu_select)
    {
    case 1:
        delay_positive_pump+=1;
        if(delay_positive_pump>10)delay_positive_pump=1;
        delay_positive_pump_eeprom=delay_positive_pump;
        break;
    case 2:
        delay_pump_def++;
        if(delay_pump_def>25)delay_pump_def=4;
        break;
    }
 }
     display_time=0;
    delay_ms(300);

}
}
/***********************************************************************************************/


void menu()
{
// 
if(!service_menu)
{
    sprintf (lcd_buf, "          ");
    LcdStringInv(1,1);
    
    if(alarm_level==0)
    {
        sprintf (lcd_buf, "  .",alarm_level);
    }
    else
    {
        sprintf (lcd_buf, "%4u",alarm_level);    
    }

    if(menu_select==1)
     {LcdStringInv(1,3);}
    else
     {LcdString(1,3);}


    if(sleep_time==0)
    {sprintf (lcd_buf, "      .");}
    else
    {sprintf (lcd_buf, "    %4u",sleep_time);}
    if(menu_select==2)
    {LcdStringInv(1,4);}
    else
    {LcdString(1,4);}

    if(sound_bit==0)
    {
        sprintf (lcd_buf, "     .");
    } else
    {
        sprintf (lcd_buf, "      .");
    }

    if(menu_select==3)
    {LcdStringInv(1,5);}
    else
    {LcdString(1,5);}

    
    sprintf (lcd_buf, "     ");
    if(menu_select==4)
    {LcdStringInv(1,6);}
    else
    {LcdString(1,6);}
    
    LcdUpdate();
} else
{
    sprintf (lcd_buf, "    ");
    LcdStringInv(1,1);
    
    
/*    sprintf (lcd_buf, "  %3u%%",Vop);
    if(menu_select==1)
    {LcdStringInv(1,4);}
    else
    {LcdString(1,4);}
*/    
    sprintf (lcd_buf, " %3u",delay_positive_pump);
    if(menu_select==1)
    {LcdStringInv(1,5);}
    else
    {LcdString(1,5);}
    
    sprintf (lcd_buf, " %3u",delay_pump_def);
    if(menu_select==2)
    {LcdStringInv(1,6);}
    else
    {LcdString(1,6);}

    LcdUpdate();


}

}
/***********************************************************************************************/


void main_window_draw()
{
unsigned char i,j;
unsigned int show_fon=0;
unsigned int div_gpaph=6;

for(i=1;i<37;i++) //    x2
{
    show_fon+=impulse_massive[i];
    switch(i)
    {
    case 4:
        if(show_fon>500) //    x4
        {
            show_fon*=9;
            i=37;
            sprintf (lcd_buf, "x9");
            LcdString(13,3);

        }
        break;

    case 9:
        if(show_fon>500) //    x4
        {
            show_fon*=4;
            i=37;
            sprintf (lcd_buf, "x4");
            LcdString(13,3);

        }
        break;

    case 18:
    if(show_fon>500) //    x2
        {
            show_fon*=2;
            i=37;
            
            sprintf (lcd_buf, "x2");
            LcdString(13,3);
    
        }
        break;

    }
} 
    sprintf (lcd_buf, "%5u", show_fon);
    LcdStringBold(1,1);

    sprintf (lcd_buf, " ");
    LcdString(11,1);
    sprintf (lcd_buf, "   ");
    LcdString(11,2);
    LcdLine (66,8, 83,8, 1);

for(i=0;i<37;i++)
{
if(impulse_massive[i]>div_gpaph)div_gpaph=impulse_massive[i];
}
j=0;
for(i=0;i<36;i++)
{
LcdLine (j, 30,  j,    30-((impulse_massive[i]*16)/div_gpaph), 1);
j++;
LcdLine (j, 30,  j,    30-((impulse_massive[i]*16)/div_gpaph), 1);
j++;
}
LcdLine (0, 30, 36, 30, 1);

    sprintf (lcd_buf, "%4u", doze_massive[26]);
    LcdString(1,5);
    if(day_tick==0){sprintf (lcd_buf, "    %02u:%02u:%02u", hour_tick,minute_tick,second_tick);}
    else{sprintf (lcd_buf, "    24:00:00");}
    LcdString(1,6);

    LcdBatt(73, 33, 83, 47, battery_procent);

    LcdUpdate();


}