void pump();
void alarm_check();
void check_battery();
void check_sbm20();
void read_adc();


/***********************************************************************************************/

void pump()
{
#pragma optsize-
unsigned int i;

if(need_pump) 
{
    GICR=0x00;
    for(i=0;i<delay_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(13);
        #asm("wdr")
    }
    delay_us(5);
    need_pump=0;
    GICR=0xC0;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
}
}

//  ********************************************************************


void alarm_check()
{
    if((rad_fon>alarm_level)&(!user_cancel_alarm))
    {
    beep=1;display=1;alarm=1;if (second%2) vibra=1; else vibra=0; 
            search_mode=0;
            clock_mode=0;
            today_doze_mode=0; 
            all_doze_mode=0; 
            volts_mode=0;
            fon_mode=0;
            menu_active=0;
        fon_mode=1; 
    }
    if((rad_fon<alarm_level)||(user_cancel_alarm)){beep=0;alarm=0; vibra=0;}
}

//  ********************************************************************

void check_battery()
{
unsigned int pump_v=10, pump_mf;
 read_adc();


if(VoltLevel<410) //    4.1,   .
{
pump_mf = ((410-VoltLevel)/10)*pump_v;  


impulse_pump=impulse_pump_def+pump_mf;
delay_pump=delay_pump_def+pump_mf;
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}

/*
unsigned int pump_multipiller=100;
 read_adc();

if(VoltLevel<420) //    4.2,   .
{
pump_multipiller=(((420-VoltLevel)*100)*3)/420;
impulse_pump=impulse_pump_def+((impulse_pump_def*pump_multipiller)/100);
delay_pump=delay_pump_def+((delay_pump_def*pump_multipiller)/100);
#asm("wdr")
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}
*/
 
 if(VoltLevel<300) //    3 ,  .  2.7  ,   3     
 {
         beep = 1;
         delay_ms(40);
         beep = 0;
         delay_ms(40);
         beep = 1;
         delay_ms(40);
         beep = 0;
         delay_ms(70);
         beep = 1;
         delay_ms(40);
         beep = 0;
         #asm("wdr")
 }

}
//  ********************************************************************

void check_sbm20()
{
if(rad_fon==0){error_count++;}
else{error_count=0;}

 if(error_count>3) { need_pump=1; pump(); } //     :)       
 if(error_count>5) //    ,  .
 {
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
 }

}
//  ********************************************************************

void read_adc()
{       unsigned int  tmpv=0;
        unsigned char ixi=64,MCUCR_def;

        #asm("sei");        //   
        // ADMUX= 0b11100111;
        // ADCSRA=0b10011111;
ADCSRA |=	(1 << ADEN) // 
			|(0 << ADSC) //  
			|(0 << ADFR) //  
			|(1 << ADIE) //  
			|(1 << ADPS2)|(1 << ADPS1)|(0 << ADPS0); //   64 (  125kHz   8mHz)

ADMUX |= (0 << REFS1)|(1 << REFS0) //  AVCC
		|(1 << ADLAR) //     , ADCL  
		|(0 << MUX0)|(1 << MUX1)|(1 << MUX2)|(1 << MUX3); //  ADC14, .. . 
                
    MCUCR_def=MCUCR; 
        MCUCR=0x90;      //    
        delay_us(125);
        TIMSK=0x00; 
        while(ixi>0)
        {
         #asm("sleep");    //   
         #asm("wdr");
         tmpv+=VoltLevel;                   
         ixi--;
        }
    TIMSK=0x41; 
        MCUCR=MCUCR_def;       //   .
        ADCSRA=0x00; 
    ACSR=0x00; 
    ADMUX=0x00;   //       
            
        VoltLevel=(tmpv>>6);
        //VoltLevel=111;
}
