eeprom unsigned char delay_pump_def=18;     //           (330 )
eeprom unsigned char impulse_pump_def=10;     //              (330 )
eeprom int time_to_display=60;    //    .  
eeprom int alarm_level=60;         //    

#define alarm_counter 3              //             
                                     //          


// [     216  ( 3 . 36 .) 
//   8   .  ,       1600 /,      
//       ,   1600      :)
//       Shodan : rad_interval=35; rad_massive[36]; .. 36
 

  
unsigned int rad_interval_def=143;//       = <>-1     0-   
unsigned int rad_massive[144]; //   (rad_interval+1), ..   .   


unsigned int rad_interval=143;//       = <>-1     0- 


unsigned int rad=0; //    
unsigned int rad_fon=0; //  
unsigned int rad_hour=0; //    24 
unsigned long fulldoze=0; //    ( ,   )
unsigned int rad_cnt=0; //  
bit counted=0; //          
bit blink=0; //     /
bit blink_led_on_pulse=1; //  

unsigned int fon_hour_approx=0;

unsigned int sutki=0;
unsigned char hours=0;

unsigned char minutes=0;
unsigned long doze=0;
unsigned long day_doze=0;

unsigned int impulse_pump;
unsigned int delay_pump;
unsigned int s, x, iv, ivc;
unsigned int peak, rcnt;  

eeprom unsigned int wdt_error @0x10;  


unsigned long tem;
unsigned int display;
// unsigned int temd;
bit need_pump=0;
unsigned char second=0;

unsigned char second_tick=0;
unsigned char minute_tick=0;
unsigned char hour_tick=0;
unsigned char menu_select=0;


unsigned char beep_on_pulse=1; //  
unsigned char vib_on_pulse=0;

unsigned int search_imp=0;

unsigned int key_press=0;
unsigned int key_press_x=0;

unsigned int VoltLevel=0;

bit reset_by_wdt=0;

bit alarm=0;
unsigned char alarm_cnt=0;
bit user_cancel_alarm=0;

bit today_doze_mode=0;
bit all_doze_mode=0;
bit volts_mode=0;
bit fon_mode=1;
bit search_mode=0;
bit clock_mode=0;
bit menu_active=0;
bit scroll=0;
bit scroll_off=0, hello=1;
bit power_on_off;

bit menu_set_time_h=0;
bit menu_set_time_m=0;
bit menu_set_disp=0;
bit menu_set_alarm=0;
bit menu_set_pump=0;
bit menu_set_imp_pump=0;


int test_fon_counter=0;
int test_fon=0;
char test_fon_timer=0;
bit test_fon_true=0;

int display_time=0;

char error_count=0; 

bit key_2_pressed=0;
bit key2_set=0;
bit poweroff_bit=0;
char dr=0, mode_counter;

#define beep     PORTB.0
#define trans    PORTD.7
#define key      PIND.3 //(int1)
#define key_2    PIND.5 //(set)
#define impulse  PIND.2 //(int0)

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#include <display.h> 
#include <microdozik.h> 


//  ********************************************************************
void check_battery();
void off();
void init_pump();
//--------------------------------- --------------------------//
interrupt [ADC_INT] void voidadc_isr(void)
{
	VoltLevel=(120*255)/(ADCH-1); // 1.16  ( 8   1.01  1.2      ADC_VALUE = V_BG * 255/Vcc)
//    VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
    //VoltLevel=1023;
}

//  ********************************************************************

interrupt [EXT_INT0] void ext_int0_isr(void)
{
#pragma optsize-
unsigned char i;

test_fon_counter++;
rad_massive[rad_cnt]++;
blink=1;
    // 
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(13);
        #asm("wdr")
    }
     delay_us(5);
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
}


//  ********************************************************************
  
interrupt [EXT_INT1] void ext_int1_isr(void)
{
#pragma optsize-
int i;
key2_set=0;

    if(alarm&(!user_cancel_alarm))
    {
        user_cancel_alarm=1;
        beep=0;
        key_press=0;  
        display_time=0;
            beep=0;
            vibra=0;
            mode_counter=4;
            return;
    }    
    // MCUCR &= ~(1<<SE);
if (!power_on_off)
{
    

if(display_time < time_to_display+1)
  {  
        if(menu_active)
        {
           menu_select++;
           scroll=1;
        }
  }    
    
    while(!key)  //    
    {
        delay_ms(100);
        // #asm("wdr")
        if(!key_2) key2_set=1; //  
        key_press++;
        
        if((key_press%10)==0)for(i=800;i>0;i--)
        {
            beep=1;
            delay_us(50);
            beep=0;
            delay_us(300);
        }
         

        if(key_press>50) //    5- ,   
        { 
        scroll_off=1;
        } 
    }
    if((key_press>=10)&(key_press<=50)&key2_set)
    {
        if(menu_active==0)
            {
                menu_active=1; scroll=1;
            }
    }
    else
    {
        if((key_press>=10)&(key_press<=50)&(!key2_set))
        {
            // 1  -
        if(search_mode) { fon_mode=1; search_mode=0; } else { fon_mode=0; search_mode=1;}
        }
    }
if ((key_press<9)&(!search_mode)&(display_time < time_to_display+1))
{
 if (!menu_active) { // 
        
    //  ,   
            mode_counter++;
if (mode_counter>4) mode_counter=0;            
            search_mode=0;
            clock_mode=0;
            today_doze_mode=0; 
            all_doze_mode=0; 
            volts_mode=0;
            fon_mode=0;
switch (mode_counter){
  {case 0: fon_mode=1; 
        break;}            
  {case 1: clock_mode=1; 
        break;}            
  {case 2: today_doze_mode=1; scroll=1; 
        break;}            
  {case 3: all_doze_mode=1;  scroll=1; 
        break;}            
  {case 4: volts_mode=1;
        break;}            
                    }        
        }
      
}
} 
else
//poff
{

    while(!key)  //    
    {
        delay_ms(100);
        // #asm("wdr")
        if(!key_2) key2_set=1; //  
        key_press++;
        
        if((key_press%10)==0)for(i=800;i>0;i--)
        {
            beep=1;
            delay_us(50);
            beep=0;
            delay_us(300);
        }
         

        if(key_press>50) //    5- ,   
        {
        power_on_off=0;
        power_on_off = 0;
        display=1;
        display_time=0;
    iv=0;
    ivc=0;
    peak=0;   
    rcnt=0;
    rad=0;
    counted=0;
    doze=0;
    day_doze=0;
    fulldoze=0;
    init_pump();
    hello=1;    
        #asm("wdr");
        }
     }
}


    key_press=0;  
    display_time=0;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

}

//  ********************************************************************



interrupt [TIM2_OVF] void timer2_comp_ovf(void)
{
    
    search_imp=rad_massive[rad_cnt];
    //          . 
    if (rad_cnt == rad_interval) {rad_massive[0]=0; rad_cnt=0; counted=1;} else { rad_massive[rad_cnt+1]=0;  rad_cnt++;}
    //            
    
      
    if ((alarm_cnt >= alarm_counter)&(counted)&(!user_cancel_alarm)) {beep=1;display=1;alarm=1;search_mode=0;fon_mode=1;} 
    //     alarm_counter    -   
    if ((alarm_cnt < alarm_counter)||(user_cancel_alarm)) {beep=0;alarm=0;} //  -  
    alarm_cnt=0;

if (test_fon_timer>6) //0-5=6sec
    {
    test_fon_timer=0;
    test_fon=test_fon_counter*6;
    test_fon_counter=0;
    test_fon_true=1;
    


//     ,      
if ((test_fon<=70)&&(test_fon_true))
   {
   if (!(rad_interval==rad_interval_def))
        {
        rad_interval=rad_interval_def;
        counted=0;
        rad_cnt=0;
        #asm("wdr");        
        }
   }
else if ((test_fon>70)&&(test_fon<=100)&&(test_fon_true))
    {
   if (!(rad_interval==36))
        {
        rad_interval=36;
        counted=0;
        rad_cnt=0;        
        #asm("wdr");
        }
    }
else if ((test_fon>100)&&(test_fon<=500)&&(test_fon_true))
    {
   if (!(rad_interval==16))
        {
        rad_interval=16;
        counted=0;
        rad_cnt=0;        
        }
    }
else if ((test_fon>500)&&(test_fon<=1000)&&(test_fon_true))
    {
   if (!(rad_interval==8))
        {
        rad_interval=8;
        counted=0;
        rad_cnt=0;        
        #asm("wdr");
        }
    }
else 
    {
   if (!(rad_interval==3))
        {
        rad_interval=3;
        counted=0;
        rad_cnt=0;        
        #asm("wdr");
        }
    }
// END

    }
test_fon_timer++;

        // fulldoze = 324; //test only!
        // day_doze = 5684; //test only!
        // doze = rad_hour + fulldoze; // test only!!
    second_tick++;
    if(second_tick>59)
    {   
        fon_hour_approx += rad_fon; //   
        second_tick=0;
        minutes++;
        minute_tick++;
        check_battery();
        check_sbm20();
        if (minute_tick%5==0) user_cancel_alarm=0; 
        //      .   5    .
    }
    
    if(minute_tick>59)
    {
        rad_hour += fon_hour_approx/60;  
        doze = rad_hour + fulldoze; //      +   
        fon_hour_approx = 0; 
        minute_tick=0;
        minutes=0;
        hours++;
        hour_tick++;
    }
    if(hour_tick>23)
    {
        day_doze = rad_hour; rad_hour = 0; //     .   
        fulldoze += day_doze; //        
        hour_tick=0;
        sutki++;
        hours=0;
    }
    
    second++;

    need_pump=1;
    //delay_ms(48);
    //trans=0;
    
    // pump();
    display_time++;

    if (display_time > 254) display_time =210;

    if ((display_time > time_to_display+1)&(!search_mode)) 
            {
            menu_active=0;
            menu_select=0;
            search_mode=0;
            clock_mode=0;
            today_doze_mode=0; 
            all_doze_mode=0; 
            volts_mode=0;
            fon_mode=1;
            }
 
}

// *******************************************************************
void check_key(void)
{
 //  2
char dr=0, i;
if((!key_2)) //      
{
dr=0;
for (i=0;i<20;i++)
  { //   
   delay_ms(10);
   if(!key_2) 
   dr++;
  }
  beep=1;
  delay_ms(5);
  beep=0; 
if(dr > 5) 
    {
key_2_pressed=1;
display_time=0;
    //  , 
    }
}
 /// 2
    #asm("wdr")                                
}
// *******************************************************************
void off(void)
{
GICR |= (0<<INT0);
display=1;
display_time=0;
rad_hour=0;
doze=0;
fulldoze=0;
sutki=0;

        clearDisplayBuffer();
        clearDisplay();
       delay_ms(320);
       shift_in('B',0);
       delay_ms(320);
       shift_in('Y',0);
       delay_ms(320);
       shift_in('E',0);
       delay_ms(320);
       delay_ms(320);

        key_press=0;
        delay_ms(2000);

        power_on_off=1;
        display=0;
        display_time=time_to_display+1;

        beep=0;


}

void calculate_rad(void)
{

    iv=0;
    ivc=0;
    peak=0;   
    rcnt=0;
    rad=0;                
   
    //   
    if (counted) {s=rad_interval+1;} else {s=rad_cnt+1;} //       .  -        

    for(x=0;x<s;x++) //      .
    {
    peak += rad_massive[x];
	rad += rad_massive[x];
if (iv == 35)  // [0-35]  36  
 { 
 if (peak > alarm_level) alarm_cnt++;
 rcnt += peak; 
 peak=0;
 ivc++; 
 iv=0; 
 } 
    iv++;
    }    
         if ((counted)&&(rad_interval>36))
        {
        rad_fon = rcnt/ivc; //    36   
		} 
        else 
        {
		rad_fon = rad*36/(rad_cnt+1); // 
		}



} 

void init_pump()
{
int i;
    GICR=0x00;
    for(i=0;i<6000;i++)
    {
        i++;
        trans=1;
        delay_us(3);
        trans=0;
        delay_us(7);
        #asm("wdr")
    }
    tem=0;
    GICR=0xC0;
    delay_ms(600);
for(x=0;x<(rad_interval+1);x++){ rad_massive[x]=0;} //  .     , 

}
// ********************************************************************


void main(void)
{
unsigned long i=0;
wdt_error=0;
rad_cnt=0;

#pragma optsize-
if (MCUCSR & 0x08)    //0000 1000 
   { 
   // Watchdog Reset 
   reset_by_wdt = 1;
   wdt_error++; 
   MCUCSR=0; 
   }
MCUCSR=0;
   
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

PORTB.0=0; // 
DDRB.0=1;

PORTD.4=0; // 
DDRD.4=1;
 
PORTD.2=1; // IMPULSES
DDRD.2=0;

PORTD.3=1; // BuTT Menu
DDRD.3=0;

PORTD.5=1; // BuTT SeT
DDRD.5=0;

PORTD.7=0; //    .
DDRD.7=1;


PORTB.5=0; // a
DDRB.5=1;

PORTB.1=0; // b
DDRB.1=1;

PORTC.3=0; // c
DDRC.3=1;

PORTC.5=0; // d
DDRC.5=1;

PORTC.4=0; // e
DDRC.4=1;

PORTB.4=0; // f
DDRB.4=1;

PORTC.2=0; // g
DDRC.2=1;

PORTD.0=0; // dp
DDRD.0=1;

PORTD.1=0; // rad led
DDRD.1=1;

PORTC.0=0; // seg1
DDRC.0=1;

PORTB.3=0; // seg2
DDRB.3=1;

PORTB.2=0; // seg3
DDRB.2=1;

PORTC.1=0; // seg4
DDRC.1=1;



//TCCR0=0x02;
TCCR0=0x05;
TCNT0=0xFF;
     
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;


  ASSR = (1<<AS2);
     //        
  delay_ms(1000);
     // 3.    TCNT2, OCR2x, and TCCR2B.
  TCNT2 = 0;
     /*   = 128
       32.768 kHz / 128 / 256 =    . */
  TCCR2 |= (1<<CS22) | (1<<CS20);            



/*
ASSR=0x08;
TCCR2=0x07;
TCNT2=0xDF;
OCR2=0x00;
*/

GICR=0xC0;
MCUCR=0xB0;
GIFR=0xC0;

TIMSK=0x41;
TIMSK |= (1<<OCIE2); //     2

// delay_ms(2);

       
if(!key) //     ,    .
{
DDRC.4=0;
beep_on_pulse=0;
}


init_pump();  
iv=0;
ivc=0;
peak=0;   
rcnt=0;
rad=0;     
    
    delay_ms(20);


check_battery();
 
#asm("sei") // 

    
while (1)
 {

if (hello) {
hello=0;
display=1;
display_time=0;

        clearDisplayBuffer();
        clearDisplay();
       delay_ms(320);
       shift_in('H',0);
       delay_ms(320);
       shift_in('E',0);
       delay_ms(320);
       shift_in('L',0);
       delay_ms(320);
       shift_in('L',0);
       delay_ms(320);
       shift_in('O',1);
       delay_ms(320);
}
if (scroll_off) { scroll_off=0; off(); }
// #asm("wdr")
if(power_on_off)
    {   
        beep=0;
        power_on_off=1;
        display=0;
//        MCUCR |= ((1<<SE)|(0<<SM1)|(1<<SM0)); //  PowerSave mode
        // MCUCR|=(1<<SM1)|(0<<SM0)|(1<<SE);
//        #asm("sleep")
        #asm("wdr")
        
    } 


if (!power_on_off) { // ON 
 calculate_rad();
    if (menu_select>5) //   
    {
            menu_active=0;
            menu_select=0;
            search_mode=0;
            clock_mode=0;
            today_doze_mode=0; 
            all_doze_mode=0; 
            volts_mode=0;
            fon_mode=1;
    } 
 if(display_time < time_to_display+1)         //time_to_display    
   {
  // check_key();

  display=1;
  
//  
if ((!menu_active)&(!search_mode)) {    
 if(today_doze_mode)
 {                
//    day_doze=4540; //test only
//     tem=doze/100;
    tem=rad_hour/100;
       clearDisplayBuffer();
       clearDisplay();
       if (scroll)
       {
       delay_ms(120);
       shift_in('T',0);
       delay_ms(120);
       shift_in('o',0);
       delay_ms(120);
       shift_in('d',0);
       delay_ms(120);
       shift_in('a',0);
       delay_ms(120);
       shift_in('y',0);
       delay_ms(120);
       shift_in('*',0);
       delay_ms(120);
       shift_in('D',0);
       delay_ms(120);
       shift_in('O',0);
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(240);
       scroll=0;
       }
       clearDisplayBuffer();
       clearDisplay();
    if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
            if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
            if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
            set_char_at(((tem%100)/10), 2,1); 
            set_char_at((tem%10), 3,0);
            #asm("wdr")

       }
 }
else if(all_doze_mode)
 {
//    day_doze=4540; //test only
//     tem=doze/100;
    tem=doze/100;
       clearDisplayBuffer();
       clearDisplay();
       if (scroll)
       {
       delay_ms(120);
       shift_in('D',0);
       delay_ms(120);
       shift_in('O',0);
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('*',0);
       delay_ms(180);
      if (((sutki%1000)/100)>0)
      {
       shift_in((sutki%1000)/100,0);
       delay_ms(180);
      } 
      if (((sutki%100)/10)>0)
      {
       shift_in((sutki%100)/10,0);
       delay_ms(180);
      }
       shift_in((sutki%10),0);
       delay_ms(180);
       shift_in('*',0);
       delay_ms(180);
       shift_in('D',0);
       delay_ms(180);
       shift_in('A',0);
       delay_ms(180);
       shift_in('Y',0);
       delay_ms(240);
       scroll=0;
       }
       clearDisplayBuffer();
       clearDisplay();
    if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
            if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
            if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
            set_char_at(((tem%100)/10), 2,1); 
            set_char_at((tem%10), 3,0);
            #asm("wdr")

       }
 }
else if(clock_mode)
 {
            set_char_at(((hour_tick%100)/10), 0,0);
if (second_tick % 2) {
            set_char_at((hour_tick%10), 1,0);
                     }
                     else
                     {
            set_char_at((hour_tick%10), 1,1);
                     }                        
            set_char_at(((minute_tick%100)/10), 2,0);
            set_char_at((minute_tick%10), 3,0);
        #asm("wdr")
 }
 else if(volts_mode)
 {
    if(VoltLevel>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
            set_char_at('u', 0,0);   //  'u'
            set_char_at(((VoltLevel%1000)/100), 1,1);
            set_char_at(((VoltLevel%100)/10), 2,0);
            set_char_at((VoltLevel%10), 3,0);
        #asm("wdr")
       }
 }
else if(fon_mode)
  { 
if ((second_tick % 2)||(counted))  //      -  
             {

   if (blink)
   {
        if (blink_led_on_pulse) { rad_led=1; }
        delay_ms(16);
        if (blink_led_on_pulse) { rad_led=0; }
    blink=0;      
    }

             
   // tem=mode_counter;
   tem=rad_fon;    
       if(tem>9999)
       {
       set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);//    "- - - -" 
       }
       else
       {
            if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
            if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
            if (((tem%100)/10)>0) set_char_at(((tem%100)/10), 2,0); else set_char_at('*', 2,0);
            set_char_at((tem%10), 3,0);
            #asm("wdr")
       }
             } else { display=0; clearDisplayBuffer(); clearDisplay();}
   } 
} //  
else if (search_mode) 
   {
   check_key();
if (key_2_pressed)
    {
    if (beep_on_pulse) { beep_on_pulse=0; vib_on_pulse=1; } else { vib_on_pulse=0; beep_on_pulse=1; }
    key_2_pressed=0;
    }

   clearDisplayBuffer(); clearDisplay();
   if(beep_on_pulse)
   set_char_at('S', 0,0);   //  'S'
   else if(vib_on_pulse)
   set_char_at('V', 0,0);   //  'V'
   

   if(search_imp>999)
    {
    set_char_at('-', 1,0);
    set_char_at('-', 2,0);
    set_char_at('-', 3,0);
    } 
       else
       {
            if (((search_imp%1000)/100)>0) set_char_at(((search_imp%1000)/100), 1,0); else set_char_at('*', 1,0);
            if (((search_imp%100)/10)>0) set_char_at(((search_imp%100)/10), 2,0); else set_char_at('*', 2,0);
            set_char_at((search_imp%10), 3,0);
        #asm("wdr")
       }
    
   if (blink)
   {
        if (blink_led_on_pulse) { rad_led=1; }
        if (vib_on_pulse) vibra = 1;
        delay_ms(26);
        if (beep_on_pulse) beep = 1;
        delay_ms(3);
        vibra = 0;
        beep = 0;
        if (blink_led_on_pulse) { rad_led=0; }
    blink=0;      
    }
   }

else { //
       clearDisplayBuffer();
       clearDisplay();
/*
       if (scroll)
       {
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('N',0);
       delay_ms(120);
       shift_in('U',0);
       delay_ms(220);
       }
*/       
if(menu_select==0)
        {
       if (scroll)
       {
       delay_ms(120);
       shift_in('T',0);
       delay_ms(120);
       shift_in('I',0);
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('*',0);
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('T',0);
       delay_ms(220);
       scroll=0;
       }
   check_key();
if (key_2_pressed)
    {
    hour_tick++;
    if (hour_tick>23) hour_tick=0;
    key_2_pressed=0;
   }

if (second_tick % 2) {
            set_char_at(((hour_tick%100)/10), 0,0);
            set_char_at((hour_tick%10), 1,1);
                     }                        
            set_char_at(((minute_tick%100)/10), 2,0);
            set_char_at((minute_tick%10), 3,0);
        #asm("wdr")
        }
else if(menu_select==1)
        {
        scroll=0;
   check_key();
if (key_2_pressed)
    {
    minute_tick++;
    if (minute_tick>59) minute_tick=0; 
    second_tick=0;
    key_2_pressed=0;
   }

            set_char_at(((hour_tick%100)/10), 0,0);
            set_char_at((hour_tick%10), 1,1);
if (second_tick % 2) {
            set_char_at(((minute_tick%100)/10), 2,0);
            set_char_at((minute_tick%10), 3,0);
                     }
        #asm("wdr")
        }
else if(menu_select==2) // 
        {
       if (scroll)
       {
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('L',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('P',0);
       delay_ms(120);
       shift_in('*',0);
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('T',0);
       delay_ms(220);
       scroll=0;
       }
   check_key();
if (key_2_pressed)
    {
        if((time_to_display>=60)&(time_to_display<700))time_to_display+=60;
        if((time_to_display>=10)&(time_to_display<60))time_to_display+=10;
        if(time_to_display<10)time_to_display=10;
        if(time_to_display>600)time_to_display=10;

    key_2_pressed=0;
   }
            set_char_at(((time_to_display%1000)/100), 1,0);
            set_char_at(((time_to_display%100)/10), 2,0);
            set_char_at((time_to_display%10), 3,0);
        #asm("wdr")
        }
else if(menu_select==3) // 
        {
       if (scroll)
       {
       delay_ms(120);
       shift_in('A',0);
       delay_ms(120);
       shift_in('L',0);
       delay_ms(120);
       shift_in('A',0);
       delay_ms(120);
       shift_in('R',0);
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('*',0);
       delay_ms(120);
       shift_in('S',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('T',0);
       delay_ms(220);
       scroll=0;
       }
   check_key();
if (key_2_pressed)
    {
    if((alarm_level>=1000)&(alarm_level<5999))alarm_level+=1000;
    if((alarm_level>=100)&(alarm_level<1000))alarm_level+=100;
    if(alarm_level<100)alarm_level+=20;
    if(alarm_level>5999)alarm_level=40;
    key_2_pressed=0;
   }
            set_char_at((alarm_level/1000), 0,0);
            set_char_at(((alarm_level%1000)/100), 1,0);
            set_char_at(((alarm_level%100)/10), 2,0);
            set_char_at((alarm_level%10), 3,0);
        #asm("wdr")
        }
else if(menu_select==4) //   .
        {
       if (scroll)
       {
       delay_ms(120);
       shift_in('I',0);
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('P',0);
       delay_ms(120);
       shift_in('_',0);
       delay_ms(120);
       shift_in('D',0);
       delay_ms(120);
       shift_in('E',0);
       delay_ms(120);
       shift_in('F',0);
       delay_ms(220);
       scroll=0;
       }
   check_key();
if (key_2_pressed)
    {
        delay_pump_def++;
        if(delay_pump_def>55)delay_pump_def=4;
    key_2_pressed=0;
   }
            set_char_at(((delay_pump_def%100)/10), 2,0);
            set_char_at((delay_pump_def%10), 3,0);
        #asm("wdr")
        }        
else if(menu_select==5) //   .
        {
       if (scroll)
       {
       delay_ms(120);
       shift_in('I',0);
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('P',0);
       delay_ms(120);
       shift_in('_',0);
       delay_ms(120);
       shift_in('I',0);
       delay_ms(120);
       shift_in('M',0);
       delay_ms(120);
       shift_in('P',0);
       delay_ms(220);
       scroll=0;
       }
   check_key();
if (key_2_pressed)
    {
        impulse_pump_def++;
        if(impulse_pump_def>25)impulse_pump_def=2;
    key_2_pressed=0;
   }
            set_char_at(((impulse_pump_def%100)/10), 2,0);
            set_char_at((impulse_pump_def%10), 3,0);
        #asm("wdr")
        }        
    
}  //   
  } else display=0; 

//       -    .  .
if ((counted)||((rad_interval<37)&&(rad_cnt>7))) alarm_check();

#asm("wdr");
     pump();
#asm("wdr");

     
    
} // ON 
// else poweroff();
if ((!display)&(!alarm))
        {
        clearDisplay();
        clearDisplayBuffer();
        #asm("wdr");
        #asm("sleep");
        }

 }       
}

//-------------------------------------------