#define impulse_pump_def 13        //              (330 )
#define delay_pump_timeout 1        //      
#define delay_pump_def 100          //           (330 )
#define time_to_display 91          //    .  = <>+1
#define alarm_level 60              //    
#define alarm_counter 3              //             
                                     //          



// [     216  ( 3 . 36 .) 
//   8   .  ,       1600 /,      
//       ,   1600      :)
//       Shodan : rad_interval=35; rad_massive[36]; .. 36
 

unsigned int rad_interval=215;//       = <>-1     0-   
unsigned int rad_massive[216]; //   (rad_interval+1), ..   .   


unsigned int rad=0; //    
unsigned int rad_fon=0; //  
unsigned int rad_hour=0; //    24 
unsigned long fulldoze=0; //    ( ,   )
unsigned int rad_cnt=0; //  
bit counted=0; //          
bit blink=0; //     /
bit blink_led_on_pulse=1; //   
bit was_in_menu=0; //        .       
unsigned int sutki=0;
unsigned char hours=0;
unsigned char minutes=0;
unsigned long doze=0;
unsigned long day_doze=0;

unsigned int impulse_pump;
unsigned int delay_pump;
unsigned int s, x, iv, ivc;
unsigned int peak, rcnt;  

eeprom unsigned int wdt_error @0x10;  


unsigned int tem;
unsigned int display;
unsigned int temd;
bit need_pump=0;
unsigned char second=0;

unsigned char second_tick=0;
unsigned char minute_tick=0;
unsigned char hour_tick=0;


unsigned int beep_on_pulse=1; //  
unsigned int key_press=0;
unsigned int key_press_x=0;

unsigned int VoltLevel=0;

bit reset_by_wdt=0;

bit alarm=0;
unsigned char alarm_cnt=0;
bit user_cancel_alarm=0;

bit doze_mode=0;
bit volts_mode=0;
bit hours_mode=0;
bit fon_mode=1;
bit search_mode=0;

char display_time=0;

char error_count=0; 


#define beep     PORTC.4
#define trans    PORTD.1
#define key      PIND.3 //(int1)
#define impulse  PIND.2 //(int0)

#include <mega8.h>
#include <delay.h>
#include <stdio.h>

#include <display.h> 
#include <microdozik.h> 


//  ********************************************************************
void check_battery();


//--------------------------------- --------------------------//
interrupt [ADC_INT] void voidadc_isr(void)
{
    VoltLevel=((unsigned int)ADCH-1)*2; // 1023 - 5 
    //VoltLevel=1023;
}

//  ********************************************************************

interrupt [EXT_INT0] void ext_int0_isr(void)
{
unsigned char i;
        #asm("wdr")
rad_massive[rad_cnt]++;
blink=1;

    // 
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(7);
        #asm("wdr")
    }
     delay_us(25);
}


//  ********************************************************************
  
interrupt [EXT_INT1] void ext_int1_isr(void)
{

    key_press_x=0;
    if(doze_mode)doze_mode=0;
    if(hours_mode)hours_mode=0;
    if(volts_mode)volts_mode=0;
    
    if ((!alarm)&&(display_time < time_to_display)) //      -    
    {
        if(search_mode) { fon_mode=1; search_mode=0; } else { fon_mode=0; search_mode=1;}
    }     
    if (was_in_menu) { fon_mode=1; search_mode=0; was_in_menu=0; } //       

    while(!key)  //    
    {   
        clearDisplay();
        delay_ms(100);
        key_press++;
        if(key_press>20) //    2 ,  1      
        {
//            PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=1; PORTC.3=0;PORTC.2=0;PORTC.1=0;PORTC.0=0; //on
//            PORTD.6=1;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
        key_press_x++;

  switch (key_press_x){
  {case 1: // d
        beep=1; delay_ms(100); beep=0;  
        PORTD.6=0;PORTD.5=1;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=0;PORTB.2=1; PORTB.5=1; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
        delay_ms(400);            
        PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
        break;}
  {case 2: // H  
        beep=1; delay_ms(100); beep=0;
        PORTD.6=0;PORTD.5=1;PORTB.0=1;PORTB.1=0;PORTB.3=1;PORTB.4=1;PORTB.2=1; PORTB.5=0; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
        delay_ms(400);
        PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
        break;}
  {case 3: // U
        beep=1; delay_ms(100); beep=0;  
        PORTD.6=0;PORTD.5=0;PORTB.0=1;PORTB.1=1;PORTB.3=1;PORTB.4=0;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
        delay_ms(400);
        PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
        break;}
  {case 4: // --  
        beep=1; delay_ms(100); beep=0;
        PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=1; PORTB.5=0; PORTC.3=1;PORTC.2=0;PORTC.1=0;PORTC.0=1; //on
        delay_ms(400);
        PORTD.6=0;PORTD.5=0;PORTB.0=0;PORTB.1=0;PORTB.3=0;PORTB.4=0;PORTB.2=0; PORTB.5=0; PORTC.3=1;PORTC.2=1;PORTC.1=1;PORTC.0=1; //off
        break;}
   }
            delay_ms(700);
        }
    }
        if(key_press>20) //    2 ,   
        {
            was_in_menu=1;
            if(key_press_x==1)
            {
            doze_mode=1; //  
            hours_mode=0;
            volts_mode=0;
            }
            if(key_press_x==2)
            {
            doze_mode=0; //  
            hours_mode=1;
            volts_mode=0;
            }
            if(key_press_x==3)
            {
            doze_mode=0; //  
            hours_mode=0;
            volts_mode=1;
            }
            if(key_press_x>3)
            {
            doze_mode=0; // 
            hours_mode=0;
            volts_mode=0;
            }
            search_mode=0;
            display_time=0;
            display=1;
            beep=0;
           
         } 
    key_press=0;
    display_time=0;
    clearDisplayBuffer();
    clearDisplay();
    if(alarm)user_cancel_alarm=1;
    #asm("wdr") 
}

//  ********************************************************************



interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
    TIFR |= (1<<TOV2);
    TCNT2=0xDF; //   

    //          . 
    if (rad_cnt == rad_interval) {rad_massive[0]=0; rad_cnt=0; counted=1;} else { rad_massive[rad_cnt+1]=0;  rad_cnt++;}
    //            

      
    if ((alarm_cnt >= alarm_counter)&(counted)&(!user_cancel_alarm)) {beep=1;display=1;alarm=1;search_mode=0;fon_mode=1;} 
    //     alarm_counter    -   
    if ((alarm_cnt < alarm_counter)||(user_cancel_alarm)) {beep=0;alarm=0;} //  -  
    alarm_cnt=0;

    second_tick++;
    if(second_tick>59)
    {   
        second_tick=0;
        minutes++;
        minute_tick++;
        check_battery();
        check_sbm20();
        if (minute_tick%5) user_cancel_alarm=0; 
        //      .   5    .
    }
    
    if(minute_tick>59)
    {
        rad_hour += rad_fon; //       
        doze = rad_hour + fulldoze; //      +    
        minute_tick=0;
        minutes=0;
        hours++;
        hour_tick++;
    }
    if(hour_tick>23)
    {
        day_doze = rad_hour; rad_hour = 0; //     .   
        fulldoze += day_doze; //        
        hour_tick=0;
        sutki++;
        hours=0;
    }
    
    second++;
    need_pump=1;
    // pump();
    display_time++;
    if (display_time > 100) display_time =96; 
}

// *******************************************************************

void calculate_rad(void)
{

    iv=0;
    ivc=0;
    peak=0;   
    rcnt=0;
    rad=0;                
   
    //   
    if (counted) {s=rad_interval+1;} else {s=rad_cnt+1;} //       .  -        

    for(x=0;x<s;x++) //      .
    {
    peak += rad_massive[x];
	rad += rad_massive[x];
if (iv == 35)  // [0-35]  36  
 { 
 if (peak > alarm_level) alarm_cnt++;
 rcnt += peak; 
 peak=0;
 ivc++; 
 iv=0; 
 } 
    iv++;
    }    
         if (counted)
        {
        rad_fon = rcnt/ivc; //    36   
		} 
        else 
        {
		rad_fon = rad*36/(rad_cnt+1); // 
		}


/*
unsigned int s, x, iv, ivc;
unsigned int peak, rcnt;  

    iv=0;
    ivc=0;
    peak=0;   
   
    //   
    if (counted) s=rad_interval+1; else s=rad_cnt+1; //       .  -        
    rcnt=0;
    rad=0;                

    for(x=0;x<s;x++) //      .
    {
    peak = peak+rad_massive[x];
if (iv > 34)  // [0-35]  36  
 { 
 if (peak > alarm_level) alarm_cnt++;
 rcnt += peak; 
 rad += peak; 
 peak=0;
 ivc++; iv=0; 
 } 
    iv++;
    }    

        if ((rad_cnt < 37)&&(!counted))
        {
        rad_fon = rad;
        } 
        else 
        {
        s=ivc+1;
        rad_fon = rcnt/s; //    36   
        }
*/        
} 

// ********************************************************************


void main(void)
{
unsigned long i=0;
wdt_error=0;
rad_cnt=0;

#pragma optsize-

if (MCUCSR & 0x08)    //0000 1000 
   { 
   // Watchdog Reset 
   reset_by_wdt = 1;
   wdt_error++; 
   MCUCSR=0; 
   }
MCUCSR=0;
   
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
 

PORTB=0x3F;
DDRB=0x3F;
PORTC=0x0F;
DDRC=0x1F;
PORTD=0x6C;
DDRD=0x62;

//TCCR0=0x02;
TCCR0=0x05;
TCNT0=0xFF;
     
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x07;
TCNT2=0xDF;
OCR2=0x00;

GICR=0xC0;
MCUCR=0xB0;
GIFR=0xC0;

TIMSK=0x41;

// delay_ms(2);

       
if(!key) //     ,    .
{
DDRC.4=0;
beep_on_pulse=0;
}


    GICR=0x00;
    for(i=0;i<120000;i++)
    {
        i++;
        trans=1;
        delay_us(3);
        trans=0;
        delay_us(7);
        #asm("wdr")
    }
    tem=0;
    GICR=0xC0;  
iv=0;
ivc=0;
peak=0;   
rcnt=0;
rad=0;     
for(x=0;x<(rad_interval+1);x++){ rad_massive[x]=0;} //  .     , 
    
    delay_ms(20);


check_battery();
 
#asm("sei") // 


while (1)
 {
 calculate_rad();
 
 if(display_time < time_to_display)         //time_to_display    
   {
 display=1;  
 if(doze_mode)
 {
     tem=doze/100;
    temd=day_doze/100;
       clearDisplayBuffer();
       clearDisplay();
    if(tem>9999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
       delay_ms(240);
       shift_in('d',0);
       delay_ms(240);
       shift_in('o',0);
       delay_ms(240);
       shift_in('s',0);
       delay_ms(240);
       shift_in('e',0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(240);
       shift_in('A',0);
       delay_ms(240);
       shift_in('L',0);
       delay_ms(240);
       shift_in('L',0);
       delay_ms(240);
       shift_in('_',0);
       delay_ms(240);
      if ((tem/1000)>0)
      {
       shift_in((tem/1000),0);
       delay_ms(240);
      }
      if (((tem%1000)/100)>0)
      {
       shift_in(((tem%1000)/100),0);
       delay_ms(240);
      }
       shift_in(((tem%100)/10),1);
       delay_ms(240);
       shift_in((tem%10),0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(240);
       shift_in('D',0);
       delay_ms(240);
       shift_in('A',0);
       delay_ms(240);
       shift_in('Y',0);
       delay_ms(240);
       shift_in('_',0);
       delay_ms(240);
      if ((temd/1000)>0)
      {
       shift_in((temd/1000),0);
       delay_ms(240);
      }
      if (((temd%1000)/100)>0)
      {
       shift_in(((temd%1000)/100),0);
       delay_ms(240);
      }
       shift_in(((temd%100)/10),1);
       delay_ms(240);
       shift_in((temd%10),0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(600);
       #asm("wdr")
       }
 }
else if(hours_mode)
 {
       clearDisplayBuffer();
       clearDisplay();
    if(sutki>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
       shift_in('*',0);
       delay_ms(240);
       shift_in('d',0);
       delay_ms(240);
       shift_in('a',0);
       delay_ms(240);
       shift_in('y',0);
       delay_ms(240);
       shift_in('_',0);
       delay_ms(240);
      if (((sutki%1000)/100)>0)
      {
       shift_in((sutki%1000)/100,0);
       delay_ms(240);
      } 
      if (((sutki%100)/10)>0)
      {
       shift_in((sutki%100)/10,0);
       delay_ms(240);
      }
       shift_in((sutki%10),0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(240);
       shift_in('h',0);
       delay_ms(240);
       shift_in('o',0);
       delay_ms(240);
       shift_in('u',0);
       delay_ms(240);
       shift_in('r',0);
       delay_ms(240);
       shift_in('_',0);
       delay_ms(240);
       shift_in(((hours%100)/10),0);
       delay_ms(240);
       shift_in((hours%10),0);
       delay_ms(240);
       shift_in('*',0);
       delay_ms(600);
        #asm("wdr")
       }
 }
else if(volts_mode)
 {
    if(VoltLevel>999){set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);} 
       else
       {
            set_char_at('u', 0,0);   //  'u'
            set_char_at(((VoltLevel%1000)/100), 1,1);
            set_char_at(((VoltLevel%100)/10), 2,0);
            set_char_at((VoltLevel%10), 3,0);
        #asm("wdr")
       }
 }
else if(fon_mode)
  { 
if ((second_tick % 2)||(counted))  //      -  
             {
   tem=rad_fon;    
       if(tem>9999)
       {
       set_char_at('-', 0,0);set_char_at('-', 1,0);set_char_at('-', 2,0);set_char_at('-', 3,0);//    "- - - -" 
       }
       else
       {
            if ((tem/1000)>0) set_char_at((tem/1000), 0,0); else set_char_at('*', 0,0); // 
            if (((tem%1000)/100)>0) set_char_at(((tem%1000)/100), 1,0); else set_char_at('*', 1,0);
            if (((tem%100)/10)>0) set_char_at(((tem%100)/10), 2,0); else set_char_at('*', 2,0);
            set_char_at((tem%10), 3,0);
            #asm("wdr")
       }
             } else { display=0; clearDisplayBuffer(); clearDisplay();}
   } 
else 
   {
   display=0; clearDisplayBuffer(); clearDisplay(); 
   if (blink)
   {
if ((beep_on_pulse)||(blink_led_on_pulse)) //     
        {
        if (blink_led_on_pulse) { digit_2=0;seg_dp=0; }
        if (beep_on_pulse) beep = 1;
        delay_ms(20);
        if (beep_on_pulse) beep = 0;
        if (blink_led_on_pulse) { digit_2=1;seg_dp=1; }
        }
    blink=0;      
    }
   }
  } else display=0; 

//       -    .  .
if (counted) alarm_check();

#asm("wdr");
    pump();
#asm("wdr");

if ((!display)&(!alarm))
        {
        clearDisplay();
        clearDisplayBuffer();
        #asm("wdr");
        #asm("sleep");
        }
     
    
 }       
}

//-------------------------------------------