void pump();
void calc_counters();
void alarm_check();
void check_battery();
void check_sbm20();
void read_adc();

/***********************************************************************************************/
void pump()
{
unsigned int i;
/*if(need_pump_by_impulse>0)
{
    GICR=0x00;
    for(i=0;i<impulse_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(5);
        #asm("wdr")
    }
    need_pump_by_impulse--;
    GICR=0xC0;
}
  */

if(need_pump) 
{
    GICR=0x00;
    for(i=0;i<delay_pump;i++)
    {
        trans=1;
        delay_us(2);
        trans=0;
        delay_us(10);
        #asm("wdr")
    }
    delay_us(25);
    need_pump=0;
    GICR=0xC0;
}
}

//********************************************************************

void calc_counters()
{
unsigned long doze=0; 
char i;
impulse_count=0;
for(i=0;i<37;i++)impulse_count+=impulse_massive[i];
if(!doze_mode)tem=impulse_count;

#asm("wdr")
 if(second>36)
 {
       check_sbm20();
       impulse_count=0;
       second=0;
       impulse_massive[0]=0;
       ready=1;
 }  
 
 //display=1;
 //display_time=1;
 //doze_mode=1;
        
 if(!doze_mode)
 {  if(impulse_count!=impulse_count_old)
    {
       impulse_count_old=impulse_count;
       
       if(tem>9999)
       {
            razl_1=10; //    "- - - -"
            razl_2=10;
            razl_3=10;
            razl_4=10;
       }
       else
       {
            razl_1=tem/1000;    // 
            razl_2=(tem%1000)/100;
            razl_3=(tem%100)/10;            
            razl_4=tem%10;
            #asm("wdr")
       }
    }
 }

 else
 {
    for(i=0;i<24;i++)doze+=doze_massive[i]/100;
    
    tem=doze/100;
    #asm("wdr")
    if(tem>9999){razl_1=10;razl_2=10;razl_3=10;razl_4=10;}
       else
       {
        razl_1=tem/1000;    // 
        razl_2=(tem%1000)/100;
        razl_3=(tem%100)/10;
        razl_4=tem%10;
        #asm("wdr")
       }
 }
}

//********************************************************************

void alarm_check()
{
    if((impulse_count>60)&(!user_cancel_alarm)){beep=1;display=1;alarm=1;}
    if(impulse_count<60){beep=0;alarm=0;user_cancel_alarm=0;}
}

//********************************************************************

void check_battery()
{
unsigned int pump_multipiller=100;
 read_adc();

if(VoltLevel<420) //    4.2,   .
{
pump_multipiller=(((420-VoltLevel)*100)*3)/420;
impulse_pump=impulse_pump_def+((impulse_pump_def*pump_multipiller)/100);
delay_pump=delay_pump_def+((delay_pump_def*pump_multipiller)/100);
#asm("wdr")
}
else
{
impulse_pump=impulse_pump_def;
delay_pump=delay_pump_def;
}


 if(VoltLevel<330) //    3.3,  .
 {
         beep = 1;
         delay_ms(30);
         beep = 0;
         delay_ms(60);
         beep = 1;
         delay_ms(30);
         beep = 0;
         delay_ms(60);
         beep = 1;
         delay_ms(30);
         beep = 0;
         #asm("wdr")
 }

}
//********************************************************************

void check_sbm20()
{
if(impulse_count==0){error_count++;}
else{error_count=0;}

 if(error_count>5) //    ,  .
 {
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
         delay_ms(600);
         #asm("wdr")
         beep = 1;
         delay_ms(1000);
         #asm("wdr")
         beep = 0;
 }

}
//********************************************************************

void read_adc()
{       unsigned int  tmpv=0;
        unsigned char ixi=64,MCUCR_def;

        #asm("sei");        //   
	    ADMUX= 0b11100111;
		
	ADCSRA=0b10011111;
    MCUCR_def=MCUCR; 
        MCUCR=0x90;	  //    
        delay_us(125);
        TIMSK=0x00; 
        while(ixi>0)
        {
         #asm("sleep");    //   
         #asm("wdr");
	     tmpv+=VoltLevel;                   
         ixi--;
        }
	TIMSK=0x41; 
        MCUCR=MCUCR_def;       //   .
        ADCSRA=0x00; 
	ACSR=0x00; 
	ADMUX=0x00;   //       
            
        VoltLevel=(tmpv>>6);
        //VoltLevel=111;
}
